#include <p16F887.inc>
 __CONFIG    _CONFIG1, _LVP_OFF & _FCMEN_OFF & _IESO_OFF & _BOR_OFF & _CPD_OFF & _CP_OFF & _MCLRE_OFF & _PWRTE_ON & _WDT_OFF & _INTRC_OSC_NOCLKOUT
 __CONFIG    _CONFIG2, _WRT_OFF & _BOR21V

DS_DAT	
DS_SIGN	
SEND	
COUNT	
NUM1	
NUM2	
NUM3	
DATA1	
HALF
DUMMY0
DUMMY1
DUMMY2
DUMMY5
DUMMY6
BITS
COMPARE	
SET_TEMP
ADDR

;--------------------------------------------------------------------
;RA0 - RS -  0,    , 1 - 
;RA2 - E -     -       
;RA1 - RW -  0 - ,  1 - 
; RB0-RB7 = DB0-DB7
#define	 DQ	PORTA,4
#define  RS PORTA,0  ; (0)/(1)
#define  E PORTA,2  ; .
#define  RW PORTA,1  ; (0)/(1)
 
 org   0
;-------------------------------------------------------------------------------------------------
;    
;--------------------------------------------------------------------------------------------------
 clrf  STATUS
 BCF   INTCON,GIE ; 
 CLRF  PORTA   ; PORTA
 clrf  PORTC
 clrf  PORTD
 
 bsf   STATUS,RP0 ; 1
 movlw  b'00000111' ;  tmr0,     tmr0
 movwf  OPTION_REG ;      (1:256)
 
 movlw  B'00000000' ;PORTD PORTA
 movwf  TRISA  ; 
 movwf  TRISB  ; 
 bsf   STATUS,RP1 ;
 clrf  ANSEL
 bcf   STATUS,RP0 ; 0
 bcf   STATUS,RP1 ;
;--------------------------------
 call wait13MS
 call wait13MS
 call wait13MS
 call wait13MS
 call wait13MS   ;  
;--------------------------------
 movlw  B'00111000' ;      
 movwf  PORTB
 call  STROB
;--------------------------------
 movlw  B'00111000' ;      
 movwf  PORTB
 call  STROB
;--------------------------------
 movlw  B'00111000' ;      
 movwf  PORTB
 call  STROB
;--------------------------------
 movlw  B'00000001' ;  
 movwf  PORTB
 call  STROB
;--------------------------------
 movlw  B'00001111' ;       
 movwf  PORTB
 call  STROB
;-------------------------------- 
;**********************************************************************
;    		                              *
;**********************************************************************

Start
	call	Init_Port
	movlw	0x20
	movwf	SET_TEMP
	bsf	PORTA,4		; Off relay, first
	movlw	0x80
	movwf	ADDR
	clrf	COUNT		; Get message from table
	call Send

Send
 bsf   RS
  movlw  41 ; A      
  movwf  PORTB
  call   STROB
  movlw  6C ; L      
  movwf  PORTB
  call   STROB
  movlw  65 ; E      
  movwf  PORTB
  call   STROB
  movlw  78 ; X      
  movwf  PORTB
  call   STROB
;--------------------------------
 bcf   RS
 movlw  B'11000000' ;    
 movwf  PORTB
 call  STROB
;--------------------------------
 bcf   RS
 movlw  B'11010100' ;    
 movwf  PORTB
 call  STROB
 bsf    RS
 movlw  3A ; K      
 movwf  PORTB
 call   STROB
 movlw  29 ;       
 movwf  PORTB
 call   STROB
goto   $   ; wait here
;--------------------------------
;      13 
;--------------------------------
STROB:
 bsf   E   ; E,  0
 nop
 nop
 nop
 bcf   E
wait13MS:
 bcf   INTCON,T0IF ;    
 CLRF  TMR0  ;  
wait:
 btfss  INTCON,T0IF ; ,     
 goto  wait
 bcf   INTCON,T0IF ;    
 return
;--------------------------------
;**********************************************************************
;    	SetPort I/O of PIC16F628	                              *
;**********************************************************************
Init_Port clrf	PORTA		; Clear PORTA before initial
	movlw	0x07		; Set PORTA to digital I/O
;	movwf	CMCON
	bsf	STATUS,RP0
	movlw	b'11101111'	; Set RA0, RA1 and RA3 as input, RA4 as output
	movwf	PORTE
	movlw	b'00000110'	; Use PORTB for LCD
	movwf	PORTB
	bcf	STATUS,RP0
	return
;**********************************************************************
;    	Read Data From DS1820		                              *
;**********************************************************************
RD_Temp	call	DS_Rx		; Check DS1820 status
	addlw	0x01		; 255=ready, 0= ready 
	btfss	STATUS,Z	; Zero flag set = ready
	return			; W register is not zero = not ready
Get_Temp call	DS_Reset	; Reset chip first
	btfss	STATUS,Z	; Zero flag set = OK
	goto	Error_		; If not response, exit
	movlw	0xcc		; Skip ROM command
	call	DS_Tx		; Send command
	movlw	0xbe		; Read scratch pad command
	call	DS_Tx		; Send command
	call	DS_Rx		; Read 8-bit data
	movwf	DS_DAT		; Save data to register
	call	DS_Rx		; Sign (FF=-VE, 00=+VE)
	movwf	DS_SIGN		; Save 9th bit to register 
	call	DS_Reset	; Restart
	movlw	0xcc		; Skip ROM command
	call	DS_Tx		; Send command
	movlw	0x44		; Start convert command
	call	DS_Tx		; Send command

	movf	DS_SIGN,w	; Check dign 
	btfsc	STATUS,Z	; Check dign = 00 ?
	goto	Pass		; If yes, Temp as positive then return
	addlw	0x01		; 
	btfss	STATUS,Z	; Check sign = FF ?
	goto	Error_		; If not, end with error
Pass	retlw	0x00		; If Yes, (Temp as negstive then return	
Error_	retlw	0x01
	
;**********************************************************************
;    	MACRO For DS1820		                              *
;**********************************************************************
DQLOW	macro
	bcf	DQ		; DQ bit ready
	bsf	STATUS,RP0
	bcf	DQ		; Set DQ to output
	bcf	STATUS,RP0
	endm

DQHIZ	macro
	bsf	STATUS,RP0
	bsf	DQ		; Set DQ to input
	bcf	STATUS,RP0
	endm

PAUSE	macro	DELAY		; Generate delay time
	movlw	DELAY
	movwf	DUMMY0
	call	DelayAL
	endm

;**********************************************************************
;    	DS1820 SubRoutine				   *
;**********************************************************************
DelayAL	nop			; Use for pausing macro
	nop
	decfsz	DUMMY0,f
	goto	DelayAL
	return

;**********************************************************************
;    	Reset DS1820						      *
;**********************************************************************
DS_Reset DQLOW
	PAUSE	0x77		; 600 microsecond delay
	DQHIZ
	PAUSE	0x0c		; Wait 67 microsecond for response bit
	nop
	nop
	movf	PORTE,w
	andlw	0x01		; Use RA0 only
	movwf	DUMMY1
	PAUSE	0x3b		; 300 microsecond delay
	movf	DUMMY1,w	; Response in W register
	return

;**********************************************************************
;    	Send Data To DS1820 (8 Bit)                                   *
;**********************************************************************
DS_Tx	movwf	DUMMY2		; Transmission data 
	movlw	0x08		; Prepare 8-bit counter for sending data
	movwf	DUMMY1		; Define loop counter
Tx_Loop	DQLOW			; Macro of DQ pin to low, This is start bit
	PAUSE	0x01		; 10 microsecond delay
	rrf	DUMMY2,f	; Rotate data to Carry flag
	btfsc	STATUS,C	; Test Carry flag
	bsf	DQ		; If Carry flag = "1" , set DQ to high
	PAUSE	0x0d		; 70 microsecond delay
	DQHIZ
	nop
	decfsz	DUMMY1,f	; 8 times ?
	goto	Tx_Loop		; No, send again
	return	

;**********************************************************************
;    	Recieve Data From DS1820 (8 Bit)		              *
;**********************************************************************
DS_Rx	movlw	0x08		; Recieve 8-bit data
	movwf	DUMMY1
Rx_Loop	DQLOW			; Macro of DQ pin to low, this is start bit
	PAUSE	0x01		; 10 microsecond delay
	DQHIZ			; Back to high for receiving
	nop
	nop
	movf	PORTE,w		; Read data
	andlw	0x01		; Get data bit 0 only
	addlw	0xff		; Move data bit 0 to Carry flag with addition method
	rrf	DUMMY2,f	; Move data bit 0 to DUMMY bit 7
	PAUSE	0x0b		; 60 microsecond delay
	decfsz	DUMMY1,f	; Loop 8 times
	goto	Rx_Loop		; Read again
	movf	DUMMY2,w	; Save data to W register
	return
end